﻿<%@ Application Language="C#" %>

<script runat="server">
        
    void Application_Start(object sender, EventArgs e) 
    {
        // Code, der beim Starten der Anwendung ausgeführt wird.
    }

    /// <summary>
    /// Code, der beim Beenden der Anwendung ausgeführt wird.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    void Application_End(object sender, EventArgs e) 
    {
        Orisa.Webframework.WebApplication.Clear();
    }
        
    void Application_Error(object sender, EventArgs e) 
    { 
        // Code, der bei einem nicht behandelten Fehler ausgeführt wird.
    }

    /// <summary>
    /// Code, der beim Starten einer neuen Sitzung ausgeführt wird.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    void Session_Start(object sender, EventArgs e) 
    {
        Orisa.Webframework.WebApplication.CountSession(1);
    }

    /// <summary>
    /// Code, der am Ende einer Sitzung ausgeführt wird. 
    /// Hinweis: Das Session_End-Ereignis wird nur ausgelöst, wenn der sessionstate-Modus
    /// in der Datei "Web.config" auf InProc festgelegt wird. Wenn der Sitzungsmodus auf StateServer 
    /// oder SQLServer festgelegt wird, wird das Ereignis nicht ausgelöst.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    void Session_End(object sender, EventArgs e) 
    {
        Orisa.Webframework.WebApplication.CountSession(-1);

        object o = Session[Orisa.Webframework.DefaultWebPage.SESSIONKEY];
        if ((o != null) && (typeof(Orisa.Webframework.Session) == o.GetType()))
        {
            Orisa.Webframework.Session session = (Orisa.Webframework.Session)o;
            session.FinalizeSession();
        }
    }
       
</script>
