﻿function DialogSection(id,ref){
    Section.call(this, id, ref);

    this.CSS_CLASS_DIALOG = "dialog";
}

DialogSection.prototype = new Section();

(function(){
    cc.sectionMap[cc.cnst.s_dlg] = new DialogSection(cc.cnst.s_dlg);
})();

DialogSection.prototype.evalDialog = function (sP, dObj, cObj)
{
    if(dObj.visible)
    {
        if(dObj.aux.css)
        {
            sP.className = this.CSS_CLASS_DIALOG + " " + "pg" + dObj.aux.css;
            this.aux.pgName = "pg" + dObj.aux.css;
        }
        else
            sP.className = this.CSS_CLASS_DIALOG;

        this.aux.btnCross = util.getNode(sP, "div", { id: util.getId(this.id, "closeDlg"), css: "closeDlg" });

        // Dialog ist ein Kontextmenü?
        if(this.aux.evt)
        {
            // Position aus vorbereitetem Event auslesen
            sP.style.left = (this.aux.evt.pageX) + "px";
            sP.style.top = (this.aux.evt.pageY + 20) + "px";
            var _this = this;
            // anywhere-Click-Control vorbereiten (btnCross auslösen, wenn außerhalb des Fensters geklickt wurde)
            util.registerFlyout(this.aux.btnCross, [function (cE, evt) { if(!_this.sP.contains(cE)) cntrls[_this.aux.btnCross.id]["click"][0](); } ]);
        }
        else
        {
            // attach to current scroll position
            sP.style.top = pageYOffset + "px";
            if(dObj.aux[cc.cnst.aux_width])
                sP.style.maxWidth = dObj.aux[cc.cnst.aux_width] + "px";
        }
        // Focus wird zentral gesetzt (setNextFocus()!)
        this.isDlg = true;
        cc.pushDialog(dObj.id, this.sP, true);
    }
    else
    {
        this.destroy();
        cc.popDialog(dObj.id, true);
    }
}
DialogSection.prototype.addCloseButton = function (dVArr)
{
    //cancel-Button anlegen
    var cObj = this.aux.btnCross;
    var dV, i = dVArr.length - 1;
    while(dV = dVArr[i])
    {
        if(dV.id == cc.cnst.id_btnCancel)
        {
            if(dV.selected)
                util.registerCE(cObj, "click", { ce: dV.aux[cc.cnst.aux_action] });
            util.toggleClass("vis", cObj, dV.selected);
            break;
        }
        i--;
    }

}
/**
 * Dialoge vorsichtig auskehren (Schließenkreuz bleibt drin),
 * wenn aber suizid (d.h. der Dialog wird wirklich geschlossen!), dann tot!
 */
DialogSection.prototype.flushOut = function (suizide)
{
    if(suizide)
        AbstractSection.prototype.flushOut.call(this, suizide);
    else if(this.sP)
    {
        var node = null;
        while(node = this.sP.lastChild)
        {
            if(util.hasClass("closeDlg", node))
            {
                util.removeClass("vis", this.aux.btnCross);
                break;
            }
            else
                util.recRemove(node, true);
        }
    }
    this.aux = { btnCross: this.aux.btnCross };
};