        var actionHolder = {};
        var cntrls = {};
        var lFL = {};
        
        function addFormEvents()
        {
            util.attachEvt("focusin", null, catchEvent);
            util.attachEvt("focus", null, catchEvent);
            util.attachEvt("click", null, catchEvent);
            util.attachEvt("change", null, catchEvent);
            util.attachEvt("keydown", null, catchEvent);
            //            util.attachEvt("mousedown", null, catchEvent);
            //            util.attachEvt("mouseup", null, catchEvent);
            util.attachEvt("contextmenu", null, catchEvent);

            if(cc.isTouchable)
            {
                util.attachEvt(null, "touchstart", catchEvent);
                util.attachEvt(null, "touchend", catchEvent);
            }
            // diese gehen nur so:
            //prevents opening the IE browser help
            document.onhelp = nop;

            cc.cntrls = cntrls;
        }
        var cEF = null;
        //var evtEvalEnabled = true;
        function catchEvent(cEvt)
        {
            var rV = true;
            try
            {
                var cE = null, any = null;
                if(cEvt == null)
                    cEvt = self.event;

                var culprit = cE = cEvt.target || cEvt.srcElement;
                var isClickEvt = cEvt.type == "click";

                if(cEvt.type == "focusin")
                {
                    cc.nextFocus = cE;
                    return;
                }

		        while(!cE.id && cE.parentNode && cE.parentNode != cE)
		        {
			        // Event dürfen nicht über vCont bubbeln!
                    if(cE.tagName == "BODY" || cE.tagName == "HTML" || cE.className == "vCont")
			        {/*
			            // F1 muss auch gehen, wenn kein Element mit id gefunden wird!
			            // auf cE wird getestet, aber schön ist es so noch nicht!
			            if(cEvt.type == "keydown")
			                break;
			            else
			                return false;*/
			            break;
			        }
			        else
			            cE = cE.parentNode;
			    }

			    // High prio: 
			    if((isClickEvt || cEvt.type == "keydown" || cEvt.type == "touchstart") && (any = cntrls["anywhere"]))
			    {
                    // Wenn flyout-Button selbst getoggelt wird -> ignorieren (Menübutton!)
			        if (any.id === cE.id)
			        {
                        // Löschen nur, wenn die Funktion an diesem Event hängt (Test mit Hit?)
			            if (cntrls[cE.id][cEvt.type])
			                delete cntrls["anywhere"];
			            // das "flyout"-Event zuerst laufen lassen, sonst ruckelt es unschön
			            // muss auch bei window-Events gehen
			        }
			        else
			        {
			            var fLst = null;
			            if (any.fn)
			                fLst = any.fn;
			            else
			                fLst = cntrls[any.id][cEvt.type] || [];
			            for (var i = 0; i < fLst.length; i++) fLst[i](cE, cEvt);

			            // nur wenn eine Funktion gefunden wurde, anywhere entfernen:
			            if (fLst.length > 0)
			                cntrls["anywhere"] = null;
			        }
			        cc.traceInfo("catchEvent()", "any: " + cntrls["anywhere"]);
			    }

			    // evaluate window events?
			    if(cE.tagName === "HTML" || cE === document) 
                    return false;

			    // 1. guess: das 1. Control, was oberhalb des auslösenden liegt und eine id hat oder das auslösende selbst + aktuelles Event:
			    var fLst = (cntrls[cE.id] && cntrls[cE.id][cEvt.type]) ? cntrls[cE.id][cEvt.type] : [];
			    var kLst = [cE.id, cEvt.type];
			    if(fLst.length == 0 && isClickEvt && cE !== culprit && culprit.childNodes.length == 1 && culprit.childNodes[0].id)
			    {
			        // das 1. und einzige Kind liefert die id (workflow):
                    cE = culprit.childNodes[0];
			        fLst = (cntrls[cE.id] && cntrls[cE.id][cEvt.type]) ? cntrls[cE.id][cEvt.type] : [];
			        kLst = [cE.id, cEvt.type];
			    }
                else if(fLst.length == 0)
			    {
			        fLst = (cntrls[cE.parentNode.id] && cntrls[cE.parentNode.id][cEvt.type]) ? cntrls[cE.parentNode.id][cEvt.type] : [];
			        kLst = [cE.parentNode.id, cEvt.type];
			    }
			    if(fLst.length == 0 && util.hasClass("td", cE) && cE.childNodes.length == 1)
			    {
                    
			        // check child (table cells, aber nicht, wenn "btnLst" oä.!)
			        cE = cE.childNodes[0];
			        fLst = (cntrls[cE.parentNode.id] && cntrls[cE.parentNode.id][cEvt.type]) ? cntrls[cE.parentNode.id][cEvt.type] : [];
			        kLst = [cE.parentNode.id, cEvt.type];
			    }

			    // 2. guess: gibt es eine globale Action für Section + Event (für Tabellen)?
                // (an Radiobutton und Checkboxen kein Change dazu, die führen nur ihr ClickHandling aus!)
			    if(fLst.length == 0 && (cEvt.type != "change" || (cE.type != "radio" && cE.type != "checkbox")))
			    {
			        var sId = cE.id.split(util.keyDlm)[0];
			        var globalEvts = cntrls[sId];
			        fLst = (cntrls[sId] && cntrls[sId][cEvt.type]) ? cntrls[sId][cEvt.type] : [];
			        kLst = [sId, cEvt.type];
			    }
			    cc.traceInfo("catchEvent()", kLst.join(":") + "(" + culprit.tagName + ", " + cE.id + "), fLst:" + fLst.length);

                // nicht bubbeln, wenn es eine event-Behandlung gibt
                var cancelBubble = fLst && fLst.length > 0;
			    var cTagName = cE.tagName.toUpperCase();
                var isTextfield = util.isTextField(cE);
			    switch (cEvt.type)
			    {
			        case "focus":
			            if(fLst.length > 0)
			            {
			                for(var i = 0; i < fLst.length; i++) fLst[i](cE, cEvt);
			            }
			            break;
			        case "blur":
			            if(fLst.length > 0)// && (cEF && cEF.id == cE.id && cEF.val != cE.value || (cntrls[cE.id] && cntrls[cE.id].notifyAlways == true)))
			            {
			                cc.delayGP = true;
			                for(var i = 0; i < fLst.length; i++) fLst[i](cE, cEvt);
			            }
			            else
			                cancelBubble = false;
			            cEF = null;
			            break;
			        case "change":
			            if(fLst.length > 0)
			            {
			                cc.delayGP = true;
			                for(var i = 0; i < fLst.length; i++) fLst[i](cE, cEvt);
			            } //cEF = null;
			            //cE.blur(); // weg setzen
			            cancelBubble = false;
			            break;
			        case "click":
			        case "context":
			            // Select, Input und Textarea brauchen keine Click-Behandlung (außer änderbaren Radiobutton und Checkboxen)
			            // #114210 Zeilen-Highlighting, wenn in ein vorhandenes input-text-Control geklickt wird -> Klick auf die Zeile
			            if(isTextfield)
			            {
                            // für Zeilenmarkierung muss expl. die globale click-Action geholt werden (an der Zelle hängt nur die change-Action!)
			                var sId = cE.id.split(util.keyDlm)[0];
			                var globalEvts = cntrls[sId];
			                if(globalEvts)
			                {
			                    fLst = (globalEvts && globalEvts[cEvt.type]) ? globalEvts[cEvt.type] : [];

			                    var _row = cE.parentNode.parentNode;
			                    if(util.hasClass("tr", _row) && !util.hasClass("mark1", _row))
			                    {
			                        var _fLst = (globalEvts[cEvt.type]) ? globalEvts[cEvt.type] : [];
			                        if(_fLst.length > 0)
			                        {
			                            for(var i = 0; i < _fLst.length; i++) _fLst[i](cE, cEvt);
			                            cancelBubble = true;
			                        }
			                    }
			                }
			            }
			                // Das Event wird einer Checkbox zugeordnet, diese wurde aber nicht getroffen und hat entspr. nicht den Zustand geändert,
                            // sonst: alte wird abgewählt, aber neue wurde noch nicht selektiert -> die Gruppe wechselt in default-Zustand, deshalb ignorieren!
			            else if (cE.tagName == "INPUT" && cE.type == "checkbox" && cE != culprit)
			                cancelBubble = true;
			            else if (fLst.length > 0 && !isTextfield && cE.readOnly != true && !cE.hasAttribute("disabled"))
			            {
			                for(var i = 0; i < fLst.length; i++) fLst[i](cE, cEvt);
			                cancelBubble = false;
			            }
			            // Kein cancelBubble:
			            // - Klick für Radiobutton & Checkboxen muss durchlaufen, sonst werden sie nicht markiert: s.o.
			            // - falls es neben onclick noch einen "echten" Link gibt, muss der aufgehen  
			            if(cancelBubble && (cE.href && unescape(cE.href).indexOf("void 0") == -1))
			                cancelBubble = false;
			            break;
				    case "keyup":
				        if(fLst.length > 0)
				        {
				            for(var i = 0; i < fLst.length; i++) fLst[i](cE, cEvt);
				        }
				        break;
				    case "keydown":
				        /*
				        // event.keyCode -> 112 "F1"; 113 "F2"; 114 "F3"; 115 "F4"; 116 "F5"; 117 "F6"; 118 = "F7"; 119 "F8"; 120 "F9"; 121 "F10";	122 "F11"; 123 "F12";
				        // modifiers -> event.shiftKey, event.shiftLeft,event.altKey, event.altLeft, event.ctrlKey, event.ctrlLeft,
				        */
				        var key = cEvt.which || cEvt.keyCode;
				        switch(key)
				        {
				            //Enter     
				            case 13:
				                //Nur Input-/Password-Controls hören auf Enter, wenn sich was geändert hat oder immer:
				                // ( Fall 1 -> Daten kommunizieren! )
				                if(isTextfield)// && cEF && cEF.id == cE.id && (cEF.val != cE.value || (cntrls[cE.id] && cntrls[cE.id].notifyAlways == true)))
				                {
				                    fLst = (cntrls[cE.id] && cntrls[cE.id]["enter"]) ? cntrls[cE.id]["enter"] : null;

				                    // 2. guess: gibt es eine globale Action für Section + Enter umbiegen! (für Tabellen & Dialoge)?:
				                    if(!fLst)
				                    {
				                        var sId = cE.id.split(util.keyDlm)[0];
				                        fLst = (cntrls[sId] && cntrls[sId]["enter"]) ? cntrls[sId]["enter"] : [];
				                    }
				                    if(fLst)
				                    {
				                        for(var i = 0; i < fLst.length; i++) fLst[i](cE, cEvt);
				                    }
				                    // update
				                    cancelBubble = fLst && fLst.length > 0;
				                }
				                else
				                {
				                    // ( Fall 2 -> Default-Button klicken, wenn vorhanden! )
				                }
				                break;
				            //BackSpace   
				            case 8:
                                // readonly-Felder akzeptieren den Focus, dürfen aber kein Backspace-Back zulassen!
				                if(isTextfield && cE.getAttribute("readonly"))
				                    cancelBubble = true;
				                break;
				            //Tab     
				            case 9: break;
				            case 27:
				                // Escape in Eingabefeldern:
				                // wenn Wert geändert: durchlaufen lassen -> vorhergeh. Zustand wird def.-mäßig wieder hergestellt
				                // sonst wird ein vorh. Dialog geschlossen
				                if(isTextfield && cE.defaultValue != cE.value)
				                    cancelBubble = false;
				                else
				                {
				                    // Escape in Dialogen behandeln
				                    var dlg = cc.getLastDialog();
				                    if(dlg)
				                    {
				                        var topCross = cc.sectionMap[dlg.id].aux.btnCross;
				                        if(util.hasClass("vis", topCross))
				                        {
				                            fLst = cc.cntrls[topCross.id]["click"];
				                            if(fLst)
				                            {
				                                for(var i = 0; i < fLst.length; i++) fLst[i](topCross, null); ;
				                            }
				                            cancelBubble = true;
				                        }
				                    }
				                }
				                break;
				            //Scrollen in HitListen mit up/ down:      
				            case 38:
				            case 40:
				                if(typeof (vScroller) != "undefined" && vScroller)
				                {
				                    vScroller.scrollTop += (key == 38 ? -22 : 22);
				                }
				                break;
				            case 84: // Alt + t -> Trace-Fenster anzeigen
				                if(cEvt.altKey)
				                {
				                    if((!traceWindow || traceWindow.closed) && typeof setTraceMode == "function")
				                    {
				                        // default: alle Meldungen
				                        setTraceMode("", "2");
				                        // Fenster registrieren
				                        cc.dialogIdx.trace = traceWindow;
				                    }
				                    cancelBubble = true;
				                }
				                break;
				            //F1: Klick auf die Help-Taste simulieren:     
				            case 112:
				                cEvt.keyCode = 0;
				                break;
				            //F5: unterbinden:     
				            case 116:
				                cEvt.keyCode = 0;
				                break;
				        }
				        break;
//				    case "mousedown":
				    case "touchstart":
                        // scheint nicht zu helfen
				        cc.delayGP = true;
				        // nicht canceln (swipe-Events!)
		                break;
//		            case "mouseup":
		            case "touchend":
		                cc.delayGP = false;
//		                break;
		            default:
		                break;
		        }
		        if(cancelBubble)
		        {
		            abortEvent(cEvt);
		            //cc.traceError("catchEvent()", cEvt.type + ": cancelled!");
		        }
            }
            catch(ex)
            {
                cc.traceError("catchEvent()",ex.stack);
            }
            return rV;
        }
        function abortEvent(cEvt)
        {
            if(typeof cEvt.preventDefault != "undefined")
            {
                cEvt.preventDefault();
                cEvt.stopPropagation();
            }
            else
                cEvt.keyCode = 0;
            cEvt.cancelBubble = true;
            cEvt.returnValue=false;
            return false;
        }

        // Eingabefelder zum Fokussieren vormerken (focusable und nicht von einem Dialog verdeckt!)
        function checkFocus(cObj)
        {
            //cc.traceError("checkFocus()", cObj.id + " - " + cObj.tagName);

            // ungültige Controls verwerfen
            if (cc.requiresFocus && (!document.body.contains(cc.requiresFocus)))
                cc.requiresFocus = null;

            // Nur das 1. cObj darf initial übernommen werden!
            if (!cc.requiresFocus)
            {
                if (util.isEditableControl(document.activeElement))
                    cc.requiresFocus = document.activeElement;
                else if (util.isEditableControl(cObj))
                    cc.requiresFocus = cObj;
            }
        }
        function nop(cEvt)
        {
            if(cEvt == null)
                cEvt = self.event;
            return abortEvent(cEvt);
        }
        