﻿    function OAjaxHandler()
    {
        this.req = null;
        
        // Functions to create xhrs
        function createStandardXHR()
        {
            try
            {
                //cc.traceError("OAjaxHandler().createStandardXHR()", "return new window.XMLHttpRequest()");
                return new window.XMLHttpRequest();
            } catch(e) { }
        }

        function createActiveXHR()
        {
            try
            {
                //cc.traceError("OAjaxHandler().createActiveXHR()", "return new window.ActiveXObject(\"Microsoft.XMLHTTP\")");
                return new window.ActiveXObject("Microsoft.XMLHTTP");
            } catch(e) { }
        }

        //cc.traceError("OAjaxHandler()", typeof (window.XMLHttpRequest) + ", " + typeof(window.ActiveXObject));
        this.createNewRequest = cc.isOwf || window.ActiveXObject ?	function ()
	    {
	        return !cc.isOwf && createStandardXHR() || createActiveXHR();
	    } :createStandardXHR;

	    this.readyStateChangeHandler = function (request, handler, getXML)
	    {
	        var fct = function ()
	        {
	            if(handler && request.readyState == 4 && request.status == 200)
	            {
	                // Session?
	                if(request.responseText.substr(0, 6) == "<html>")
	                    restart(false);
	                else if(getXML && getXML == true)
	                    handler(request.responseXML);
	                else
	                    handler(request.responseText);
	            }
	            else
	            {
	                //cc.traceError("OAjaxHandler.readyStateChangeHandler()", "state: " + request.readyState + ", status: " + request.status + ", handler: " + typeof (handler));
	            }
	        }
	        return fct;
	    }
        /**
         * Request wird null gesetzt */
	    this.abortPendingRequest = function ()
	    {
	        if((this.req != null) && (this.req.readyState != 0) && (this.req.readyState != 4))
	        {
	            //cc.traceError("OAjaxHandler.abortPendingRequest()", "state: " + this.req.readyState + ", status: " + this.req.status);
	            this.req.abort();
	        }
	    }
        this.submitNewRequest = function (url, handler)
        {
            try
            {
                this.abortPendingRequest();
                this.req = this.createNewRequest();
                this.req.onreadystatechange = this.readyStateChangeHandler(this.req, handler);
                this.req.open('GET', url, true);
                this.req.send(null);
            }
            catch(ex)
            {
            }
        }
    }