function Util()
{
    this.keyDlm = "_x_";
    this.rIdxDlm = "@@";
    this.cmpVal = { DC: -1, FALSE: 0, TRUE: 1 };
}
Util.prototype.showKanjiMessage = function showKanjiMessage(s)
{
    alert(this.getUnicodeMessage(s));
}
Util.prototype.getUnicodeMessage = function getUnicodeMessage(s)
{
    s = s.replace(/\'/g, "\\'");
    s = s.replace(/\"/g, "\\\"");
    return eval(("\"" + s + "\"").replace(/&#(\d+);/g, "\"+String.fromCharCode(parseInt(\"$1\",10))+\"").replace(/\n/g, "\\n"));
};
// Reihenfolge beachten!
Util.prototype.convJsToHTML = function (s)
{
    //s = s.replace(/&/g, "&amp;");
    s = s.replace(/</g, "&lt;");
    s = s.replace(/>/g, "&gt;");
    s = s.replace(/\n/g, "<br/>");
    //s = s.replace(/\"/g, "&quot;");
    //s = s.replace(/\'/g, "&#39;");
    return s;
};
Util.prototype.joinSearchString = function (arr)
{
    var search = "";
    for(key in arr)
    {
        if(!arr[key])
            continue;
        if(search.length > 0)
            search += "&";
        search += key + "=" + arr[key];
    }
    return search;
};
Util.prototype.getClonedObj = function (p)
{
    var cloned = {};
    for (var key in p)
        cloned[key] = p[key];
    return cloned;
};
Util.prototype.getChildNodeByIdx = function (node, idx)
{
    var cIdx = 0;
    var rV = null;
    if(node != null && node.childNodes)
        for(var i = 0; i < node.childNodes.length; i++)
        {
            var child = node.childNodes[i];
            if(child.nodeType == 1)
            {
                if(cIdx == idx)
                {
                    rV = child;
                    break;
                }
                cIdx++;
            }
        }
    return rV;
};
// Allgem. Closure-Getter, damit nicht jede Seite einen haben muss
Util.prototype.registerCE = function (pId, pEvt, param)
{
    // Alles muss da sein, sonst geht es nicht
    if(!(pId && pEvt && param && (param.ce || param.fn))) return null;
    var id = pId, cObj = null;
    // String oder Array von Events ist zulssig
    var pEvts = typeof pEvt == "string" ? [pEvt] : pEvt;
    // pId kann statt des Idents auch ein Objekt tragen
    if(typeof id == "string")
        cObj = document.getElementById(pId);
    else
    {
        if(id.id)
        {
            cObj = pId;
            id = cObj.id;
        }
        else
        // falls sich kein Ident ermitteln lsst, kann das Event zumindest nicht in die Liste eingetragen werden
        // weiter beobachten
            return null;
    }
    // Objekt in der Control-Liste finden bzw. anlegen
    var evtLst = cc.cntrls[id];
    if(!evtLst)
        cc.cntrls[id] = evtLst = {};
    for(var i = 0; i < pEvts.length; i++)
    {
        var evt = pEvts[i];
        var fn = param.fn || this.createFN(param.ce, cObj, evt);
        if(typeof fn == "function")
            fn = [fn];
        evtLst[evt] = fn;
        //cc.traceInfo("Util.registerCE()", "cc.cntrls['" + id + "']['" + evt + "'] registered: " + typeof (cc.cntrls[id][evt]));
    }
};
Util.prototype.registerFlyout = function (cntrl, fn)
{
    if(cntrl)
        cc.cntrls["anywhere"] = {id:cntrl.id, cObj: cntrl, fn: fn};
}
// "number" & CO mssen auch als "text" durchgehen
Util.prototype.isTextField = function isTextField(cObj)
{
    return cObj && cObj.tagName == "INPUT" && !(cObj.type == "hidden" || cObj.type == "radio" || cObj.type == "checkbox");
}
// Falls zur Laufzeit ein Wert ersetzt werden muss, obj + evt mitgeben!
Util.prototype.createFN = function createFN(cE, cObj, evt)
{
    if(cE == null)
        return null;
    // cObj kommt aus catchEvent()!
    return function (cObj, evt)
    {
        var myP = {}, cRow, nEF;
        if(cE && !(evt && evt.type == "change" && (nEF = cc.nextFocus) && cObj !== nEF && cObj.parentNode.contains(nEF)))
        {
            if(typeof cE == "string")
                myP = cE;
            else
            {
                if(cE.length)
                {
                    // selbstgebaute Actions
                    var keyLst = cE.length == 3 ? [cc.cnst.urlParamNames_action, cc.cnst.urlParamNames_key, cc.cnst.urlParamNames_val] : cE.length == 4 ? [cc.cnst.urlParamNames_action, cc.cnst.urlParamNames_key, cc.cnst.urlParamNames_col, cc.cnst.urlParamNames_val] : cE.length == 5 ? [cc.cnst.urlParamNames_action, cc.cnst.urlParamNames_page, cc.cnst.urlParamNames_key, cc.cnst.urlParamNames_col, cc.cnst.urlParamNames_val] : cE.length == 2 ? [cc.cnst.urlParamNames_action, cc.cnst.urlParamNames_key] : [cc.cnst.urlParamNames_action];

                    for(var j = 0; j < keyLst.length; j++)
                        myP[keyLst[j]] = cE[j];
                }
                else
                {
                    // severgenerierte Action
                    for(key in cE)
                    {
                        myP[key] = cE[key];

                        // fr rowSelect zur Zeile hochhangeln:
                        if(key == cc.cnst.urlParamNames_action && cE[key] == cc.cnst.action_rowSelect)
                        {
                            cRow = cObj;
                            while(cRow.className.indexOf("tr") == -1)
                            {
                                if(!cRow.parentNode || cRow == cRow.parentNode)
                                    break;
                                else
                                    cRow = cRow.parentNode;
                            }
                        }
                    }
                }
                if(myP[cc.cnst.urlParamNames_val] && myP[cc.cnst.urlParamNames_val] == cc.cnst.urlParamVals_val)
                {
                    if(cObj.tagName == "INPUT" && (cObj.type == "checkbox" || cObj.type == "radio"))
                        myP.VALUE = cObj.checked ? "1" : "0";
                    else if (util.hasClass("togglepanel", cObj))
                        myP.VALUE = util.hasClass("openGroup", cObj) ? "1" : "0";
                    else
                        myP.VALUE = cObj.value;
                }
                if(cObj && cObj.id)
                {
                    // Mit den folgenden Indizees wird der cObj.id interpretiert (ggf. ndern, falls das nicht ausreicht)
                    // 0 - Section
                    // 1 - Row
                    // 2 - Cell bzw. Control (keine Abfrage auf tagName!)
                    var arr = cObj.id.split(util.keyDlm);
                    if(arr.length > 1)
                    {
                        var sArr = arr[1].split(util.rIdxDlm);
                        if(sArr.length == 2)
                        {
                            myP[cc.cnst.urlParamNames_rowIdx] = sArr[1];
                        }
                        if(myP[cc.cnst.urlParamNames_key] == cc.cnst.urlParamVals_val)
                            myP[cc.cnst.urlParamNames_key] = sArr[0];
                    }
                    if(myP[cc.cnst.urlParamNames_col] && myP[cc.cnst.urlParamNames_col] == cc.cnst.urlParamVals_val && arr.length > 2)
                        myP[cc.cnst.urlParamNames_col] = arr[2];
                }
            }
            cc.fireEvent("selectItem", myP);
        }
    };
}
Util.prototype.attachEvt = function attachEvt(evt, cObj, f)
{
    if(!cObj)
        cObj = document;
    // true: Event in der capturingPhase fangen!
    if(typeof (cObj.addEventListener) != "undefined")
        cObj.addEventListener(evt, f, true);
    else if(typeof (cObj.attachEvent) != "undefined")
        cObj.attachEvent('on' + evt, f);
    else
        cObj["on" + evt] = f;
};
Util.prototype.getNode = function getNode(p, tN, aL)
{
    var id = aL ? aL.id : null;
    var cObj = id ? document.getElementById(id) : null;
    if(cObj && cObj.parentNode)
        this.applyAttrList(cObj, aL, true);
    else
        cObj = this.addNode(p, tN, aL);
    return cObj;
};
Util.prototype.addNode = function addNode(p, tN, aL)
{
    var cObj = document.createElement(tN || "DIV");
    if("a" == tN)
        cObj.href = "javascript:void 0;";

    this.applyAttrList(cObj, aL);

    (p || document.body).appendChild(cObj);
    return cObj;
};

/**
 * "css" ist der Key fr className-Liste
 * mit setAttribute() knnen auch custom data attributes gesetzt werden */
Util.prototype.applyAttrList = function applyAttrList(cObj, aL, cf)
{
    if(cObj && aL)
    {
        for(var key in aL)
        {
            if(key == "css")
            {
                if(cf)
                {
                    var sList = aL[key].split(" ");
                    for(var i = 0; i < sList.length; i++)
                    {
                        if(!this.hasClass(sList[i], cObj))
                            this.addClass(sList[i], cObj);
                    }
                }
                else
                    cObj.setAttribute("class", aL[key]);
            }
            else
            {
                // manche Attribute werden nicht ausgewertet, wenn sie bereits existieren! (z.B. value -> Defaultwert)
                if(typeof cObj[key] == "undefined")
                    cObj.setAttribute(key, aL[key]);
                else
                    cObj[key] = aL[key];
            }
        }
    }
    return cObj;
};
Util.prototype.getId = function getId(a)
{
    return this.joinArgs(arguments, this.keyDlm);
};
Util.prototype.getClassList = function (a)
{
    return this.joinArgs(arguments, " ");
};
Util.prototype.getCSV = function getCSV(a)
{
    return this.joinArgs(arguments, ", ");
};
Util.prototype.getString = function getString(a)
{
    return this.joinArgs(arguments, "");
};
Util.prototype.joinArgs = function joinArgs(arg, delim)
{
    return ([].slice.apply(arg)).join(delim);
};
Util.prototype.recRemove = function recRemove(node, selfIncl)
{
    var sectionInstance = null;
    while (node && node.childNodes.length > 0)
    {
        var child = node.childNodes[node.childNodes.length - 1];

        // falls sich zur id eindeutig eine Section zuordnen laesst und wenn sP noch nicht NULL ist:
        if (child.id && (sectionInstance = cc.sectionMap[child.id]) && sectionInstance.sP && sectionInstance.sP === child)
        {
            // reset(): erst Section als Ganzes behandeln
            sectionInstance.reset();

            delete cc.sectionMap[child.id];
            if (sectionInstance.isDialog)
                delete cc.dialogWin[child.id];

            sectionInstance.sP = null;
        }
        if (child.childNodes.length > 0)
            this.recRemove(child);
        this.removeNode(child);
    }
    if (node && selfIncl)
    {
        // falls sich zur id eindeutig eine Section zuordnen laesst und wenn sP noch nicht NULL ist
        if (node.id && (sectionInstance = cc.sectionMap[node.id]) && sectionInstance.sP && sectionInstance.sP === node)
        {
            cc.traceError("Util.removeNode()", "selfIncl: " + node.id);

            // reset(): erst Section als Ganzes behandeln
            sectionInstance.reset();

            delete cc.sectionMap[node.id];
            sectionInstance.sP = null;
        }
        this.removeNode(node);
    }
};
// DOM-Node loeschen
Util.prototype.removeNode = function (node)
{
    if (node.id)
    {
        // links?
        if (cc.anchor[node.id])
            delete cc.anchor[node.id];
        if (cc.cntrls[node.id])
            delete cc.cntrls[node.id];
    }
    node.parentNode.removeChild(node);
}

Util.prototype.joinClass = function (p, c)
{
    if (p && c)
    {
        if (!p.css) p.css = "";
        var r = new RegExp("\\b" + c + "\\b");
        if (p.css.search(r) < 0)
            p.css += " " + c;
        p.css = p.css.replace(/   */g, " ").replace(/^ | $/g, ""); // remove unwanted spaces 
    }
    return p;
};
Util.prototype.evictClass = function (cssList, cntrl)
{
    if (cssList && cntrl)
    {
        var arr = cssList.split(" ");
        for(var i=0; i < arr.length; i++)
            util.removeClass(arr[i], cntrl);
    }
};
Util.prototype.addClass = function (name, el)
{
    var _el = el || this.element;
    if(_el && name && !this.hasClass(name, el))
    {
        _el.className += " " + name;
    }
};

Util.prototype.removeClass = function (name, el)
{
    var _el = el || this.element;
    if(_el)
    {
        var className = _el.className;
        var r = new RegExp("\\b" + name + "\\b");
        if(className.search(r) >= 0)
        {
            className = className.replace(name, "");
            className = className.replace(/   */g, " ").replace(/^ | $/g, ""); // remove unwanted spaces 
        }
        _el.className = className;
    }
};

Util.prototype.hasClass = function (name, el)
{
    var _el = el || this.element;
    // document hat kein className
    if(_el && typeof _el.className != "undefined")
    {
        var r = new RegExp("\\b" + name + "\\b");
        return _el.className.search(r) >= 0;
    }
    return false;
};
// Editierbares UI-Control?
Util.prototype.isEditableControl = function (cObj)
{
    return (cObj && typeof cObj.value != "undefined" && !cObj.getAttribute("disabled") && !cObj.getAttribute("readonly"));
}

/*ueberprueft, ob eine CSS-Class am Element vorhanden ist, 
    falls ja: Class wird entfernt --> Rueckgabewert: false 
    falls nein: Class wird hinzugefuegt --> Rueckgabewert: true 
*/
Util.prototype.toggleClass = function (name, el, state)
{
    var hasClass = util.hasClass(name, el);
    
    /* Kein state -> toggle! */
    if(typeof state == "undefined")
        state = !hasClass;

    if(state && !hasClass)
        util.addClass(name, el);
    else if(!state && hasClass)
        util.removeClass(name, el);
    return state;
};
// falls jQuery besser ist, bitte ndern
Util.prototype.getStyleProperty = function (name, el)
{
    var rV = "";
    if(window.getComputedStyle)
    {
        rV = getComputedStyle(el).getPropertyValue(name);
    }
    //IE
    else if(el.currentStyle)
    {
        try { rV = el.currentStyle[name]; } catch(e) { }
    }
    return rV;
};