﻿function MatchBoxControl(section, sP, dObj)
{
    this.section = section;
    this.origId = dObj.id;
    this.id = util.getId(section.id, dObj.id);
    this.restriction = dObj.aux[cc.cnst.aux_restriction] || "";
    this.action = dObj.aux[cc.cnst.aux_action] || "";
    //this.cObj = null;
    this.button = { id: this.id + "Btn", obj: null, txt: dObj.aux[cc.cnst.aux_btnTxt] || "X" };
    this.resultList = null;
    this.lastSubList = null;
    this.toggleState = false;
    this.cOption = null;

    // normale Struktur aufbauen
    section.evalInput(sP, dObj, null);
    // falls QS initial keinen Focus bekommen soll -> zurücksetzen
//    if(cc.requiresFocus && cc.requiresFocus.id === this.id)
//        cc.requiresFocus = null;
    this.cObj = document.getElementById(this.id);
    
    // pimp parentNode (css für Button)
    var mbcContainer = this.cObj.parentNode;
    mbcContainer.id = util.getId(this.id, "c");
    mbcContainer.tabindex = "0";
    util.addClass("mbcContainer", mbcContainer);
    if (dObj.type == cc.cnst.dtp_selAutoComplete)
    {
        var _this = this;

        // das Result-Div erst dazu bauen, wenn das Eingabefeld den Fokus bekommt (der eigentliche Grund ist nicht mehr gegeben)
        util.registerCE(this.cObj, "focus", {
            fn: [function open(cObj, evt)
            {
                util.registerFlyout(_this.cObj, [function handleQS(cObj, cEvt)
                {
                    cc.traceInfo("handleQS()", cObj.id + ": " + cEvt.type);
                    if (!cObj || cObj !== _this.button.obj)
                    {
                        var arr = util.getClonedObj(_this.action);
                        arr[cc.cnst.urlParamNames_action] = cc.cnst.action_change;
                        arr[cc.cnst.urlParamNames_val] = _this.cObj.value;
                        cc.fireEvent("selectItem", arr);

                    }
                }]);

                //cc.traceInfo("MatchBoxControl.open()", cObj.value);
                if (!_this.resultList)
                {
                    _this.resultList = util.getNode(_this.cObj.parentNode, "DIV", { id: util.getId(_this.cObj.id, "results"), css: "mbcResults" });

                    // pickValue(): geklickten Link aus dem event-Objekt nehmen, in Eingabefeld schreiben und "enter" auslösen -> sofortige Suche
                    util.registerCE(_this.resultList, "click", {
                        fn: [
                            function pickValue(cObj, cEvt)
                            {
                                var val = (cEvt.target || cEvt.srcElement).getAttribute("data-ident");
                                //cc.traceInfo('pickValue()', val);
                                _this.cObj.value = val;
                                var fLst = cc.cntrls[_this.id]["enter"];
                                if (fLst) fLst[0](_this.cObj);
                                // parent bekommt den Fokus, damit die Liste zu bleibt!
                                cc.requiresFocus = _this.cObj.parentNode;
                            }]
                    });
                }
                if (cObj.value)
                {
                    _this.toggleList(true);
                    _this.evalSearch(cObj.value);
                }
            }]
        });
        // Verlassen des Suchfeldes bewirkt kein Suchen mehr (nur Enter, Button-Klick oder Klick in die Resultlist),
        // aber ResultList muss geschlossen werden bei Klick auf anywhere
        cc.cntrls[this.id].notifyAlways = true;
        // ResultList zuklappen mit Verzögerung: Auswahl eines Wertes geht >= 500 mit IE, Chrome
        util.registerCE(this.cObj, "blur", { fn: [function close(cObj, evt) { setTimeout(function () { _this.toggleList(false); }, 500); }] });

        util.attachEvt("keyup", this.cObj, function monitor(evt)
        {
            //_this.section.trace("error", _this.id + ".monitor()", "value: " + this.value + ", restriction=" + _this.restriction);
            var kC = evt.keyCode || evt.which;

            if (kC == 13)
            {
                // Schluss (Auswertung ist schon bei KeyDown passiert)
                _this.toggleList(false);
                // Button bekommt den Fokus, damit die Liste zu bleibt!
                cc.requiresFocus = _this.cObj.parentNode;
                return false;

            }
            else if (kC == 38 || kC == 40)
            {
                // up-/ down-Button 
                var rV = _this.shove(kC == 38);
                if (rV)
                    _this.cObj.value = rV;
            }
                // Wert? -> evaluate
            else if (this.value)
            {
                if (!_this.toggleState)
                    _this.toggleList(true);
                _this.evalSearch(this.value);
            }
                // kein Wert: keine Liste!
            else
                _this.toggleList(false);
        });

        // ResultList ein- und ausblenden
        this.toggleList = function toggleList(visible)
        {
            this.toggleState = util.toggleClass("openGroup", this.cObj.parentNode, visible);
            //cc.traceError("MatchBoxControl.toggleList()", visible);
        };
    }
    else
    {
        if (dObj.aux[cc.cnst.aux_action] && dObj.aux[cc.cnst.aux_action][cc.cnst.urlParamNames_action])
            dObj.aux[cc.cnst.aux_action][cc.cnst.urlParamNames_action] = cc.cnst.action_search;

        var f = util.createFN(dObj.aux[cc.cnst.aux_action] || [cc.cnst.action_search, dObj.id, "value"]);
        util.registerCE(this.cObj, "enter", { fn: f });
    }
    // Button
    var pN = { id: util.getId(this.id, dObj.id + "btn"), css: cc.cnst.dtp_btn.toLowerCase() };
    //util.joinClass(pN, dObj.aux[cc.cnst.aux_css]);

    (this.button.obj = util.addNode(this.cObj.parentNode, "a", pN)).innerHTML = this.button.txt;
    
    // input kommt vor zugehörigem Button und hat bereits Actions
    // genau diese Callback-Funktion soll der Button auslösen, deshalb enter-Event klauen und click zuweisen!
    util.registerCE(pN.id, "click", { fn: function () { cc.cntrls[_this.cObj.id].enter[0](_this.cObj); } });

    // aus MBC-Id, äußeren Kriterien und Wert des Eingabefeldes wird der SubList-Ident gebildet
    // diese wird angezeigt und, falls noch leer, durch einen AJAX-Ruf befüllt
    this.evalSearch = function (val)
    {
        var searchId = this.searchId = util.getId(this.id, this.restriction, val);
        if(this.lastSubList)
        {
            if(this.lastSubList.id == searchId)
                return false;
            util.removeClass("selected", this.lastSubList);
        }
        this.lastSubList = util.getNode(this.resultList, "div", { id: searchId, css: "selected" });
        if(this.lastSubList.childNodes.length == 0)
        {
            this.block = true;
            this.cOption = null;
            var url = util.getString(cc.webRoot, "modules/kernel/ui/data.aspx?", cc.cnst.urlParamNames_action, "=", cc.cnst.action_matchBox, "&", cc.cnst.urlParamNames_key, "=", _this.origId, "&", cc.cnst.urlParamNames_val, "=", val, "&DUMMY=0&RT=", new Date().getTime());
            if(!cc.ajaxObj)
                cc.ajaxObj = new OAjaxHandler();
            cc.useLOC(url, function (text) { _this.evalResponse(searchId, text) });
        }
    };

    // subList übernehmen
    this.evalResponse = function (subListKey, content)
    {
        var cObj = document.getElementById(subListKey);
        if(cObj)
            cObj.innerHTML = content;
        if(subListKey == this.lastSubList.id)
            this.block = false;
    };

    // Markierung in der ResultList 
    this.markResult = function markResult(cObj, mIn)
    {
        var val = cObj.getAttribute('data-ident');
        if(this.cOption && (!mIn || val != this.cOption.getAttribute('data-ident')))
        {
            this.cOption.className = "";
            this.cOption = null;
        }
        if(cObj && mIn)
        {
            this.cOption = cObj;
            this.cOption.className = "selected";
            this.cObj.value = val;
            //path.traceError(self,"mO()",this.cOption.id + ": " + this.cOption.innerText);
        }
    };

    // Markierung der ResultList entprechend der Pfeiltasten bewegen
    this.shove = function shove(up)
    {
        if(!this.block)
        {
            var lastCode = this.lastSubList.id;
            var cntnr = document.getElementById(lastCode);
            if(cntnr && cntnr.childNodes.length > 0)
                cntnr = cntnr.childNodes[0];
            if(cntnr.childNodes.length > 0)
            {
                var cObj = this.cOption;
                // noch keine Markierung oder eine im falschen Block
                if(cObj == null || cObj.parentNode.parentNode.id != lastCode)
                    cObj = cntnr.childNodes[(up ? cntnr.childNodes.length - 1 : 0)];
                else
                {
                    cObj = up ? cObj.previousSibling : cObj.nextSibling;
                    if(cObj == null)
                        cObj = cntnr.childNodes[(up ? cntnr.childNodes.length - 1 : 0)];
                }
            }
            if(cObj)
            {
                this.markResult(cObj, true);
                return cObj.id;
            }
        }
        return null;
    };

    // Update vom Server: äußere Kriterien haben sich geändert
    // update Inhalt + Sichtbarkeit
    this.reset = function reset(dObj)
    {
        // Nach Suche oder neuem Kontext muss die Box zu sein!
        this.toggleList(false);
        this.section.evalInput(sP, dObj, this.cObj);
        this.restriction = dObj.aux[cc.cnst.aux_restriction];
        // parent bekommt den Fokus, damit die Liste nach update zu bleibt!
        cc.requiresFocus = _this.cObj.parentNode;
    };
}