function ClientController(cc, wR, isOwf, cT, uOmnit, wId)
{
    this.windowIdent = wId;
    this.sectionMap = cc.sectionMap;
    this.cnst = cc.cnst;
    this.sectionIdx = [];
	this.dialogIdx = {};
    // siehe modernizr...
    this.isTouchable = (('ontouchstart' in window) || window.DocumentTouch && document instanceof DocumentTouch) ? true : false;
    this.webRoot = wR || "",
    // Wenn Bsfenster, dann kein BackButton
    this.isOwf = isOwf;
    this.useOmniture = uOmnit;
    this.title = self.document.title;
    this.rootControl = document.getElementById("ui");
    this.cT = cT;
    //this.session = session,
    this.gP = null;
    this.delayGP = false;
    //this.externalWindows = [];
    this.dialogWin = [];
    this.openDialogCount = 0;
    this.traceHandler = self;
    this.anchor = {};
    this.ajaxObj = null;
    this.isDirty = false;

    // Definition of ClientEvents
    // type == "http" -> name not used
    // type == "javascript" -> name: js function */
    this.clientEvents = {
        selectItem: [{ type: "http"}],
        changeLanguage: [{ name: "resetApplication", type: "javascript" }, { type: "http"}],
        showExternalWindow: [{ name: "showExternalWindow", type: "javascript"}],
        downloadDocument: [{ name: "downloadDocument", type: "javascript"}]
    };
}
ClientController.prototype.handleServerEvent = function (_sE, _wds, _cT)
{
    var historyState = null;

    // Handelt es sich um einen regulren Request oder einen durch history.back() ausgelsten Cache-Aufruf?
    if(!this.isOwf && this.eventQueue && this.lastState && (this.eventQueue.codeFrame.location.href.indexOf(this.eventQueue.lastUrl) == -1))
    {
        //alert(this.eventQueue.codeFrame.location.href + "\n" + this.eventQueue.lastUrl);
        // History weiterschubsen, damit wir ganz aus der Anwendung rauskommen:
        if(this.lastState.level == 0)
            history.back();
        else
            this.traceInfo("handleServerEvent()", "No?");
        return false;
    }
    try
    {
        // Initialisierung EventQueue und Glasspanes (Synchronisationsprobleme Http/OWF!)
        if(this.gP == null)
        {
            // ms -> s
            var sec = (_cT - this.cT) / 1000;
            this.traceInfo("handleServerEvent()", sec + "s (" + _cT + " - " + this.cT + ")");
            if(sec > 60)
            {
                alert("Reload wegen Verdacht auf gecachte Seite (" + sec + "s)!\n" + _cT + "\n" + this.cT);
                restart(true);
            }
            this.eventQueue = new EventQueue(frames[0], this.webRoot);
            this.gP = document.getElementById("glasspane");
            //this.darkPane = parent.document.getElementById("darkpane");
        }
        currTimeouts = 0;

        var i = 0, data = {}, dObj = null, yartAction = null;
        this.traceInfo("handleServerEvent()", _sE + ": " + _wds.length + " WDS");
        for(; i < _wds.length; i++)
        {
            dObj = _wds[i];

            // Dialoge sofort auswerten:
            switch(dObj.type)
            {
                case this.cnst.dtp_meta:
                    var cObj = null;
                    var metaList = document.getElementsByTagName('meta');
                    var pNode = metaList[0].parentNode;

                    // ACHTUNG: die Auswertung ist nur fr OGP-Tags mit property-Attribut!
                    var j = metaList.length - 1;
                    while(metaList[j])
                    {
                        if ((cObj = metaList[j]).attributes["property"])
                            pNode.removeChild(cObj);
                        j--;
                    }
                    for(var j = 0; j < dObj.dV.length; j++)
                    {
                        var dV = dObj.dV[j];
                        util.getNode(pNode, "meta", { property: dV.id, content: dV.value });
                    }
                    continue;
                    break;
                case this.cnst.dtp_dlg:
                    dObj.tL = [dObj.id];
                    break;
            }
            var targets = dObj.tL; /*
            // jsO-Arrays werden fr die einzelnen Sections angelegt und mit jsOs befllt: */
            for(var j = 0; j < targets.length; j++)
            {
                var sKey = targets[j] || this.rootControl.id;
                var s = this.sectionMap[sKey];

                // Reset DOs drfen nicht ins Getriebe kommen!
                if(dObj.type == cc.cnst.dtp_cmd)
                {
                    switch(dObj.id)
                    {
                        case cc.cnst.cmd_Reset:
                            if (s)
                            {
                                // reset + delete -> section-Tag mitlschen!
                                s.flushOut(dObj.aux[cc.cnst.aux_del]);
                                s.trace("info", "evalData()", dObj.id + ": " + sKey + "(" + dObj.desc + ")");

                                // set pgName to section reference
                                s.aux.pgName = "pg" + dObj.desc;

                                // data section carries the pgName
                                if(s.sP)
                                {
                                    s.sP.className = (s.isDlg? s.CSS_CLASS_DIALOG + " ":"") + s.aux.pgName;
                                    if (sKey == "data")
                                    {
                                        // Vor Neuaufbau Scrollzustand zurcksetzen
                                        window.scrollTo(0, 0);
                                    }
                                }

                                if(dObj.aux[this.cnst.aux_url])
                                {
                                    // 20141112; bhm; #110969 fr die Backnavigation brauchen wir Url (Bookmark/ Deeplink) und den passenden Level
                                    historyState = { level: dObj.aux[this.cnst.aux_level], url: dObj.aux[this.cnst.aux_url] };
                                }
                            }
                            continue;
                            break;
                        case cc.cnst.cmd_Timer:
                            //if(dObj.aux[] == action_checkBusy)
                            {
                                var _action = dObj.aux[this.cnst.aux_action];
                                this.polling = window.setInterval(function () { cc.poll(_action); }, 2000);
                            }
                            break;
                        case cc.cnst.cmd_dirtyFlag:
                            this.isDirty = dObj.selected;
                        case cc.cnst.cmd_msgTimeout:
                            // Wenn description, dann in txt-Liste sammeln
                            if (dObj.desc)
                                cc.cnst.txt[dObj.id] = dObj.desc;
                            break;
                        case cc.cnst.cmd_YART:
                            yartAction = dObj.aux[this.cnst.aux_action];
                            break;
                        case cc.cnst.cmd_MOD:
                            alert(dObj.desc);
                            /*  'Please close this window if it does not close automatically.'
                            // das Schlieen funktioniert fr iOS erst ab 8.1.1, deshalb als tot markieren! */
                            util.addClass("on dead", this.gP);
                            window.opener = self;
                            window.close();
                            continue;
                        case cc.cnst.cmd_loadCC:
                            // .cCom: kein webRoot!
                            frames[1].location.replace(this.addRT(dObj.aux[this.cnst.aux_action]));
                            break;
                        // 20130828; bhm; #99801 Provide Omniture surveillance                      
                        case cc.cnst.cmd_omTracePage:
                            if(typeof hit_page === 'function')
                                try { hit_page(dObj.aux); } catch(ex) { this.traceError("handleServerEvent()", ex.stack); }
                            continue;
                            break;
                        case cc.cnst.cmd_omTraceDoc:
                            if(this.useOmniture && typeof hit_download === 'function')
                            {
                                var docs = [];
                                if(dObj.aux[cc.cnst.aux_omnitDocType])
                                    docs[0] = dObj.aux;
                                else
                                {
                                    var domValues = dObj.dV;
                                    for(var j = 0; j < domValues.length; j++)
                                        docs[j] = domValues[j].aux;
                                }
                                try { hit_download(docs); } catch(ex) { this.traceError("handleServerEvent()", ex.stack); }
                            }
                            continue;
                            break;
                    }
                }
                var t = data[sKey] || [];
                t[t.length] = dObj;
                data[sKey] = t;
            }
        }
        for (var sKey in data)
        {
            // check first DO for section anchors
            dObj = data[sKey][0];

            // Section-Instanz prfen:
            var s = this.sectionMap[sKey];
            // Dialog
            if (dObj.type == cc.cnst.dtp_dlg)
            {
                // flashOut erfolgt an der Section
                if (s == null)
                {

                    this.sectionMap[sKey] = new DialogSection(sKey);
                    //this.traceInfo("handleServerEvent()", "--- DialogSection " + sKey + ": new ---");
                }
            }
                // Tree?
            else if (dObj.type == cc.cnst.dtp_tree)
            {
                if (s)
                {
                    s.flushOut(true);
                    // Kranke TreeSections entstehen durch unvollstndige DOs beim Zeilenupdate und mssen neu gebaut werden!
                    if (typeof s.evalRows != "function")
                    {
                        //this.traceInfo("handleServerEvent()", "--- TreeSection " + sKey + " ohne evalRows() !!! ---");
                        s = this.sectionMap[sKey] = null;
                    }
                }
                if (s == null)
                {

                    this.sectionMap[sKey] = new TreeSection(sKey);
                    //this.traceInfo("handleServerEvent()", "--- TreeSection " + sKey + ": new ---");
                }
            }
                // Table?
            else if (dObj.type == cc.cnst.dtp_tabHdr)
            {
                if (s)
                {
                    // Kranke TableSections entstehen durch unvollstndige DOs beim Zeilenupdate und mssen neu gebaut werden!
                    if (typeof s.evalRows != "function")
                    {
                        s.flushOut(true);
                        //this.traceInfo("handleServerEvent()", "--- TableSection " + sKey + " ohne evalRows() !!! ---");
                        s = this.sectionMap[sKey] = null;
                    }
                    else
                        // Wenn die Section in Ordnung ist, dann sP wegen der blockNav-Reihenfolge stehen lassen!
                        s.flushOut(false);
                }
                if (s == null)
                {

                    this.sectionMap[sKey] = (dObj.aux[cc.cnst.aux_dtp] == "recommended") ? new ScrollTableSection(sKey) : (dObj.aux[cc.cnst.aux_dtp] == "grid") ? new TableGridSection(sKey) : new TableSection(sKey);
                    //this.traceInfo("handleServerEvent()", "--- TableSection " + sKey + ": new ---");
                }
            }
            var topSection = dObj.aux[this.cnst.aux_topSection];
            var pSection = this.getAnchorCntrl(topSection, dObj.aux[this.cnst.aux_parent]);
            var s = this.getSection(sKey, pSection, topSection);
            s.evalData(_sE, data[sKey]);
        }
        // Grenanpassungen?
        this.adjustDimensions();

        if(yartAction)
            this.fireEvent("selectItem", yartAction);

        if(!this.isOwf)
        {
            // 20141112; bhm; #110969 Das ist die eigentliche History-Behandlung:
            // Wenn in diesem RoundTrip kein historyState-Objekt gebaut wurde, nehmen wir das letzte
            if(!historyState)
                historyState = this.lastState;
            else
            {
                // Falls ein traceLevel da ist, auch weiter mitfhren (fr Konsistenz bei reload())
                if(historyState.url.indexOf("&tracing") == -1 && this.traceHandler && this.traceHandler.traceLevel > 0 && traceWindow && !traceWindow.closed)
                    historyState.url += "&tracing=" + this.traceHandler.traceLevel;
            }
            // Wenn initial nix gebaut wurde, gibt es nix zu pushen
            if(historyState)
            {
                //this.traceInfo("handleServerEvent()", "history.length: " + history.length + ", {" + historyState.level + "," + historyState.url + "}");

                // 20141112; bhm; #110969 der initiale Aufruf steht automatisch in der History (nicht verdoppeln)
                if(this.lastState)
                {
                    // Nur push geht, damit sind wir immer am Ende der nativen History
                    top.history.pushState(historyState, "", historyState.url); // oder "this.title" als title-Parameter?
                }

                this.lastState = historyState;
            }
        }
    }
    catch(ex)
    {
        this.traceError("handleServerEvent()", ex.stack);
    }
    this.eventQueue.finishedEvent();
};
/**
 * Eine Section wird zurckgegeben, wenn sie noch nicht existiert, wird sie angelegt. */
ClientController.prototype.getSection = function (key, pNode, top)
{
    var s = this.sectionMap[key];

    // no section
    if(!s)
    {
        s = new Section(key);
        this.sectionIdx[this.sectionIdx.length] = this.sectionMap[key] = s;
    }
    if(pNode || document.body)
    {
        // die Section hat noch keinen parent DOM node oder ist verwaist
        if(!s.sP || !s.sP.parentNode)
        {
            s.sP = util.getNode((pNode || util.getNode(null, null, { id: this.rootControl.id })), "section", { id: key, "data-top": top });

            // data section carries the pgName
            if(s.aux.pgName)
                s.sP.className = s.aux.pgName;
        }
    }
    return s;
};
// Grenanpassungen nachdem alle DOs eines Roundtrips durch sind
// (Unterschied zu finalize(): Abschluss nach allen zusammengeh. DOs einer Section!)
ClientController.prototype.adjustDimensions = function ()
{
    // Scrollbereiche nur fr .mm
    if (util.hasClass("mm", document.body))
    {
        var scrollable = document.getElementsByClassName("scrollable");
        // scrollbares Element?
        if (scrollable.length > 0)
        {
            var lastHeight = scrollable[0].style.height;
            var lastScrollTop = scrollable[0].scrollTop;

            scrollable[0].style.height = "auto";
            var diff = document.body.scrollHeight - document.body.clientHeight;

            // Delta vorhanden?
            if (diff > 0)
            {
                // Mindesthhe lassen
                var minScrollHeight = 50;
                var height = (scrollable[0].clientHeight - diff);
                if (height < minScrollHeight)
                    height = minScrollHeight;
                scrollable[0].style.height = height + "px";

                // wenn sich die Scrollhhe im Vergleich zur alten nich gendert hat, die alte Scrollposition wieder herstellen
                if (lastHeight == scrollable[0].style.height)
                    scrollable[0].scrollTop = lastScrollTop;
            }
        }
    }
}
ClientController.prototype.handleResize = function ()
{
    for(var key in this.sectionMap)
    {
        var s = this.sectionMap[key];
        // TODO es sollten eigentlich nur lebende Sections in der Liste stehen!
        if(s && typeof s.resize == "function" && s.sP && s.sP.parentNode)
        {
            //this.traceInfo("handleResize()", s.id);
            s.resize();
        }
    }
    this.adjustDimensions();
}  /*
// event handling */
ClientController.prototype.fireEvent = function(cEName, cEParams)
{
    var keepGP = false;
    this.showGlasspane();
    var clientActions = null;
    if(cEParams && cEParams.clientEvent && cEParams.clientEvent == this.cnst.evtList)
    {
        // clientEvent-Liste: jedes Event richtig auflsen und mit den jew. Parametern einketten!
        cEParams = cEParams.param;
        for(var i = 0; i < cEParams.length; i++)
        {
            var listItem = cEParams[i];
            clientActions = this.clientEvents[listItem.clientEvent];
            if(clientActions)
            {
                keepGP = true;
                this.eventQueue.addQueueEvent(clientActions, listItem.param);
            }
        }
    }
    else
    {
        clientActions = this.clientEvents[cEName];
        if(clientActions)
        {
            keepGP = true;
            this.eventQueue.addQueueEvent(clientActions, cEParams);
        }
    }
    if(!keepGP)
        this.hideGlasspane();
};
ClientController.prototype.poll = function (s)
{
    var _action = s;
    this.useLOC(this.webRoot + cc.cnst.busyDlg.pollUrl + new Date().getTime(), function (text)
    {
        //cc.traceError("poll()", text + ": " + text.indexOf(cc.cnst.busyDlg.EOF));
        if(text && (text.indexOf(cc.cnst.busyDlg.EOF) == 0))
        {
            cc.stopPolling();
            cc.fireEvent("selectItem", _action);
        }
    });
}
ClientController.prototype.stopPolling = function ()
{
    window.clearInterval(this.polling);
}

/* Kleiner Dienstweg (LittleOfficialChannel) */
ClientController.prototype.useLOC = function (url, f) {
    if(!this.ajaxObj)
        this.ajaxObj  = new OAjaxHandler();
    this.ajaxObj.submitNewRequest(url, f);
};
/*  */
ClientController.prototype.downloadDocument = function (parameters)
{
    var pString = "", target = null, form = null;
    if(parameters)
    {
        for(key in parameters)
        {
            if(key == cc.cnst.urlParamNames_target)
            {
                target = parameters[key];
                form = document.createElement("form");
                continue;
            }
            /*if(target)
            {
            var input = document.createElement('input');
            input.type = 'hidden';
            input.name = key;
            input.value = parameters[key];
            form.appendChild(input);
            }
            else*/
            pString += (pString.length > 0 ? "&" : "?") + key + "=" + encodeURIComponent(parameters[key]);
        }
    }
    if(target)
    {
        //window.open("about:blank", "Test")
        form.action = this.webRoot + "modules/kernel/UI/GetBinData.aspx" + pString + "&RT=" + new Date().getTime();
        form.method = "POST";
        form.target = target;

        form.style.display = 'none';
        document.body.appendChild(form);
        form.submit();
        document.body.removeChild(form);
    }
    else
    {
        //this.traceInfo("downloadDocument()", this.webRoot + "modules/kernel/UI/GetBinData.aspx" + pString);
        // cCom
        frames[1].location.replace(this.addRT(this.webRoot + "modules/kernel/UI/GetBinData.aspx" + pString));
    }
};
ClientController.prototype.isGlasspaneActive = function () {
    return (this.gP && util.hasClass("on", this.gP));
};
ClientController.prototype.showGlasspane = function ()
{
    var dialog = this.getLastDialog();

    // Verzgerung der Glasspane nach blur-/ change-Events
    if (this.delayGP)
    {
        // Wenn delay im Dialogkontext, dann nur die nderung des zIndex verzgern, nicht die Sichtbarkeit der gP!
        util.addClass(dialog ? "delayedDlg" : "delayed", this.gP);
        setTimeout(function () { cc.stopDelay() }, 300);
    }
    util.addClass("on", this.gP);

    // Wenn delay im Dialogkontext, ...
    if (!this.delayGP && dialog && dialog.style)
    {
        this.gP.style.zIndex = dialog.style.zIndex + 1;
    }
    this.delayGP = false;
    //cc.traceInfo("showGlasspane()", this.gP.style.visibility + " - " + this.gP.style.zIndex);
};
/**
 * gP-Verzgerung beenden (evtl. ist hideGlasspane schon gelaufen)
 */
ClientController.prototype.stopDelay = function ()
{
    if (util.hasClass("delayedDlg", this.gP))
    {
        util.removeClass("delayedDlg", cc.gP)

        var dialog = this.getLastDialog();
        if (dialog && dialog.style)
        {
            this.gP.style.zIndex = dialog.style.zIndex + 1;
        }
        //cc.traceInfo("showGlasspane()", this.gP.style.visibility + " - " + this.gP.style.zIndex);
    }
    else
        util.removeClass("delayed", cc.gP)
};
/**
* Sichtbaren Dialog registrieren
*/
ClientController.prototype.pushDialog = function pushDialog(key, dlg, c)
{
    if(!cc.dialogWin[key] && c)
        cc.openDialogCount++;
    dlg.style.zIndex = 300 + cc.openDialogCount;
    cc.dialogWin[key] = { obj: dlg, timeStamp: new Date().getTime() };
}
/**
* Dialog entregistrieren
*/
ClientController.prototype.popDialog = function popDialog(key, c)
{
    if(cc.dialogWin[key])
    {
        if(c) cc.openDialogCount--;
        delete cc.dialogWin[key];
    }
}
/*
// dialog.style.zIndex trgt die Ebene, wenn sich Dialoge stapeln
// deshalb nicht berschreiben! */
ClientController.prototype.hideGlasspane = function () {
    if(this.isGlasspaneActive())
    {
        var dialog = this.getLastDialog();
        // if dialog keep the gP
        util.toggleClass("on", this.gP, (dialog != null));
        util.removeClass("delayedDlg", this.gP);
        if(dialog && dialog.style)
            this.gP.style.zIndex = dialog.style.zIndex -1;
    }
    //cc.traceInfo("hideGlasspane()", this.gP.style.visibility + " - " + this.gP.style.zIndex);
};
ClientController.prototype.getWinSize = function (win)
{
    //var restricted = typeof realSize == "undefined" || !realSize;
    var doc = win.document;
    var myWidth = 0, myHeight = 0;
    if(typeof (win.innerWidth) == 'number')
    {
        //Non-IE
        myWidth = win.innerWidth;
        myHeight = win.innerHeight;
    }
    else if(doc.documentElement && (doc.documentElement.clientWidth || doc.documentElement.clientHeight))
    {
        //IE 6+ in 'standards compliant mode'
        myWidth = doc.documentElement.clientWidth;
        myHeight = doc.documentElement.clientHeight;
    }
    else if(doc.body && (doc.body.clientWidth || doc.body.clientHeight))
    {
        //IE 4 compatible
        myWidth = doc.body.clientWidth;
        myHeight = doc.body.clientHeight;
    }
    return {w: myWidth, h: myHeight };
}
ClientController.prototype.getDocSize = function ()
{
    var B = document.body,
    H = document.documentElement,
    height = 0, width = 0;

    if(typeof document.height !== 'undefined')
    {
        width = document.width // For webkit browsers
        height = document.height // For webkit browsers
    }
    else
    {
        width = Math.max(B.scrollWidth, B.offsetWidth, H.clientWidth, H.scrollWidth, H.offsetWidth);
        height = Math.max(B.scrollHeight, B.offsetHeight, H.clientHeight, H.scrollHeight, H.offsetHeight);
    }
    return { w: width, h: height };
};
ClientController.prototype.getLastDialog = function () {
    var dialog = null;
    for (var i in this.dialogWin) {
        if (this.dialogWin[i] && (dialog == null || dialog.timeStamp < this.dialogWin[i].timeStamp)) {
            dialog = this.dialogWin[i];
        }
    }
    return dialog?dialog.obj:null;
};
//ClientController.prototype.isActiveWin = function (win)
//{
//    var rV = true;
//    var dlg = this.getLastDialog();
//    while(win && dlg)
//    {
//        if(win.frameElement.id != dlg.id)
//        {
//            if(win.parent && win.frameElement.id != win.parent.frameElement.id)
//                win = win.parent;
//            else
//            {
//                rV = false;
//                break;
//            }
//        }
//        else
//            break; ;
//    }
//    return rV;
//};
ClientController.prototype.completeURL = function (pString)
{
    pString += "&" + cc.cnst.urlParamNames_winId + "=" + this.windowIdent;
    pString += "&RT=" + new Date().getTime();
    return pString;
};
ClientController.prototype.addRT = function (pString, restricted) {
    var rt = new Date().getTime();
    if (restricted)
        rt = Math.floor(rt / 60000)
    pString += (pString.indexOf("?") == -1 ? "?RT=" : "&RT=") + rt;
    return pString;
};
ClientController.prototype.splitSearchString = function (s) {
    var arrSearch = [];
    var arr = s.split("&");
    for (i = 0; i < arr.length; i++) {
        arr[i] = arr[i].split("=");
        arrSearch[arr[i][0]] = arr[i][1];
    }
    return arrSearch;
};
//    ClientController.prototype.paramsToString = function (arr, pString) {
//        var isFirstKey = true;
//        pString += "{";
//        for (key in arr) {
//            var val = arr[key];
//            if (!val)
//                continue;
//            if (!isFirstKey)
//                pString += ",";
//            else
//                isFirstKey = false;
//            pString += key + ":";
//            if (typeof val == "string") {
//                pString += "\"";
//                pString += getUnicodeParameter(val);
//                pString += "\"";
//            }
//            else if (val.length > 0) {
//                pString += "new Array(";
//                for (var i = 0; i < val.length; i++) {
//                    if (i > 0)
//                        pString += ",";
//                    pString = paramsToString(val[i], pString);
//                }
//                pString += ")";
//            }
//            else
//                pString = paramsToString(val, pString);
//        }
//        pString += "}";
//        return pString;
//    };
//    ClientController.prototype.getUnicodeParameter = function (s) {
//        s = s.replace(/\r/g, "");
//        s = s.replace(/\n/g, "\\n");
//        s = s.replace(/\'/g, "\\'");
//        s = s.replace(/\"/g, "\\\"");
//        s = s.replace(/\\/g, "\\\\");
//        return s;
//    };
ClientController.prototype.decodeJsString = function (s) {
    var rV = "";
    if (s) {
        try {
            var i = 0;
            s = s.replace(/\'/g, "\\'"); i++;
            s = s.replace(/\"/g, "\\\""); i++;
            s = s.replace(/\r/g, ""); i++; // Werte aus entries mit Umbrchen!
            s = s.replace(/\\/g, "\\\\"); // Verdoppelt die Backslashes, damit jeweils einer das folgende eval berlebt!!! Aber wofr ist das gut?
            s = eval(("\"" + s + "\"").replace(/&#(\d+);/g, "\"+String.fromCharCode(parseInt(\"$1\",10))+\"").replace(/\n/g, "\\n")); i++;
            s = s.replace(/&lt;/g, "<"); i++;
            s = s.replace(/&gt;/g, ">"); i++;
            rV = s;
        } catch (ex) {
            this.traceError("decodeJsString()", ex.message + ", " + i);
        }
    }
    return rV;
};

ClientController.prototype.trace = function (type, col1, col2, col3) {
    this.traceHandler.doTrace(type, (col1 || this.getWinIdent(self)), col2, col3);
};
ClientController.prototype.traceInfo = function (id, val) {
    this.traceHandler.doTrace("info", this.getWinIdent(self), id, val);
};
ClientController.prototype.traceError = function (id, val) {
    this.traceHandler.doTrace("error", this.getWinIdent(self), id, val);
};
ClientController.prototype.getWinIdent = function (wObj)
{
    try
    {
        // Kann in Exception auslsen, wenn wir im Frame laufen!
        if(wObj && wObj.frameElement)
            wObj = wObj.frameElement;
    }
    catch(ex) { }
    return wObj.id || wObj.name || this.title;
};
ClientController.prototype.addAnchorCntrl = function addAnchorCntrl(context, pId, cntrl)
{
    //this.traceInfo("addAnchorCntrl()", "+ " + context + "." + pId);
    if(context && pId && cntrl)
    {
        if(this.anchor[context])
            this.anchor[context][pId] = cntrl;
        else
        {
            (this.anchor[context] = {})[pId] = cntrl;
            this.anchor[context] = {};
            this.anchor[context][pId] = cntrl;
        }
    }
}
ClientController.prototype.getAnchorCntrl = function getAnchorCntrl(context, pId)
{
    if(pId)
    {
        var pObj = (context && pId && this.anchor[context] && this.anchor[context][pId]) || null;
        if(!pObj)
//            this.traceInfo("getAnchorCntrl()", "- " + context + "." + pId + ": " + (pObj.id || pObj.className));
//        else
            this.traceError("getAnchorCntrl()", "- " + context + "." + pId + ": none!!!");
        return pObj;
    }
    return null;
}
ClientController.sectionMap = {};